#!/bin/sh
WPACONFDIR="/etc/wpa_supplicant"
WPACONFFILE="wpa_supplicant.conf"
INTERFACESDIR="/etc/network"
INTERFACESFILE="interfaces"

if [ -x wpa_passphrase ]; then
	echo "Please excute \"aptitude install wpasupplicant\""
	return 1;
fi

if [ ! -d ${WPACONFDIR} ]; then
	echo "not exist $WPACONFDIR"
	return 1
fi

if [ ! -f ${INTERFACESDIR}/${INTERFACESFILE} ]; then
	echo "not exist $INTERFACESFILE"
	return 1
fi

# input
while [ -z "$SSID" ]
do
	echo -n "SSID: "
	read SSID
done

KEY_MGMT="NONE"

while [ -z "$WEP_KEY0" ]
do
	echo -n "WEP Key: "
	read WEP_KEY0
done

WEP_TX_KEYIDX=0

#echo -n "WEP Key 1: "
#read WEP_KEY1
#if [ -n "$WEP_KEY1" ]; then
#	echo -n "WEP Key 2: "
#	read WEP_KEY2
#fi
#if [ -n "$WEP_KEY2" ]; then
#	echo -n "WEP Key 3: "
#	read WEP_KEY3
#fi
#
#while :
#do
#	echo -n "WEP Tx key index: "
#	read WEP_TX_KEYIDX
#	if [ "$WEP_TX_KEYIDX" = "0" -a "$WEP_KEY0" != "" ]; then
#		break
#	elif [ "$WEP_TX_KEYIDX" = "1" -a "$WEP_KEY1" != "" ]; then
#		break
#	elif [ "$WEP_TX_KEYIDX" = "2" -a "$WEP_KEY2" != "" ]; then
#		break
#	elif [ "$WEP_TX_KEYIDX" = "3" -a "$WEP_KEY3" != "" ]; then
#		break
#	fi
#done

# create wpa_supplicant.conf
cd $WPACONFDIR
if [ -f ${WPACONFFILE} ]; then
	cp -f $WPACONFFILE ~/${WPACONFFILE}.bak
fi
cat << EOF > $WPACONFFILE
network={
	ssid="$SSID"
	key_mgmt=$KEY_MGMT
	wep_key0=$WEP_KEY0
	wep_key1=$WEP_KEY1
	wep_key2=$WEP_KEY2
	wep_key3=$WEP_KEY3
	wep_tx_keyidx=$WEP_TX_KEYIDX
}
EOF
sed -i -e "/^.*=[:space:]*$/d" $WPACONFFILE

# edit interfaces
cd $INTERFACESDIR
cp -f $INTERFACESFILE ~/${INTERFACESFILE}.bak
sed -i -e "/wlan0/d" $INTERFACESFILE
sed -i -e "/wpa-conf/d" $INTERFACESFILE
cat << EOF >> $INTERFACESFILE
auto wlan0
iface wlan0 inet dhcp
wpa-conf /etc/wpa_supplicant/wpa_supplicant.conf
EOF

# interface restart
ifdown wlan0
ifup wlan0

return 0

