#!/bin/sh
WPACONFDIR="/etc/wpa_supplicant"
WPACONFFILE="wpa_supplicant.conf"
INTERFACESDIR="/etc/network"
INTERFACESFILE="interfaces"

if [ -x wpa_passphrase ]; then
	echo "Please excute \"aptitude install wpasupplicant\""
	return 1;
fi

if [ ! -d ${WPACONFDIR} ]; then
	echo "not exist $WPACONFDIR"
	return 1
fi

if [ ! -f ${INTERFACESDIR}/${INTERFACESFILE} ]; then
	echo "not exist $INTERFACESFILE"
	return 1
fi

## input ssid
while [ -z "$SSID" ]
do
	echo -n "SSID: "
	read SSID
done

## input proto
while :
do 
	echo "WPA Version"
	echo "1)WPA"
	echo "2)WPA2"
	echo "3)WPA2 and WPA"
	read PROTO
	case "$PROTO" in
		"1")	PROTO="WPA"; break	;;
		"2")	PROTO="WPA2"; break	;;
		"3")	PROTO="WPA2 WPA"; break	;;
	esac
done

## input key_mgmt
#fixed
KEY_MGMT="WPA-PSK"

#while :
#do 
#	echo "Tareget Users"
#	echo "1)WPA-Personal(WPA-PSK)
#	echo "2)WPA-Enterprise(WPA-EAP)
#	read KEY_MGMT
#	case "$KEY_MGMT" in
#		"1")	KEY_MGMT="WPA-PSK"; break ;;
#		"2")	KEY_MGMT="WPA-EAP"; break ;;
#	esac
#done

## input pairwise and group
while :
do 
	echo "Encryption Protocol"
	echo "1)TKIP"
	echo "2)CCMP(AES)"
	echo "3)CCMP(AES) & TKIP"
	read ENCRYPT
	case "$ENCRYPT" in
		"1")	ENCRYPT="TKIP"; break ;;
		"2")	ENCRYPT="CCMP"; break ;;
		"3")	ENCRYPT="CCMP TKIP"; break  ;;
	esac
done
PAIRWISE=$ENCRYPT
GROUP=$ENCRYPT

## input psk
while [ -z "$PSK" ]
do
	echo -n "Pass Phrase: "
	read PSK
done

### create wpa_supplicant
cd $WPACONFDIR
if [ -f ${WPACONFFILE} ]; then
	cp -f ${WPACONFFILE} ~/${WPACONFFILE}.bak
fi
wpa_passphrase "$SSID" "$PSK" > $WPACONFFILE
if [ $? -ne 0 ]; then
	echo "wpa_passphrase error"
	return 1
fi

sed -i -e "3igroup=$GROUP" $WPACONFFILE
sed -i -e "3s/^/\t/" $WPACONFFILE
sed -i -e "3ipairwise=$PAIRWISE" $WPACONFFILE
sed -i -e "3s/^/\t/" $WPACONFFILE
sed -i -e "3iproto=$PROTO" $WPACONFFILE
sed -i -e "3s/^/\t/" $WPACONFFILE
sed -i -e "3ikey_mgmt=$KEY_MGMT" $WPACONFFILE
sed -i -e "3s/^/\t/" $WPACONFFILE

cd ${INTERFACESDIR}
cp -f ${INTERFACESFILE} ~/${INTERFACESFILE}.bak
sed -i -e "/wlan0/d" $INTERFACESFILE
sed -i -e "/wpa-conf/d" $INTERFACESFILE

cat << EOF >> ${INTERFACESFILE}
auto wlan0
iface wlan0 inet dhcp
wpa-conf /etc/wpa_supplicant/wpa_supplicant.conf
EOF

ifdown wlan0
ifup wlan0

return 0

